package com.zt.plat.module.qms.business.config.dal.mapper;

import java.util.*;

import com.zt.plat.framework.common.pojo.PageResult;
import com.zt.plat.framework.mybatis.core.query.LambdaQueryWrapperX;
import com.zt.plat.module.qms.business.config.controller.vo.*;
import com.zt.plat.module.qms.business.config.dal.dataobject.ConfigAssayMethodParameterDO;
import com.zt.plat.framework.mybatis.core.mapper.BaseMapperX;
import org.apache.ibatis.annotations.Mapper;

/**
 * 检测方法参数配置 Mapper
 *
 * @author 后台管理-1
 */
@Mapper
public interface ConfigAssayMethodParameterMapper extends BaseMapperX<ConfigAssayMethodParameterDO> {

    default PageResult<ConfigAssayMethodParameterDO> selectPage(ConfigAssayMethodParameterPageReqVO reqVO) {
        return selectPage(reqVO, new LambdaQueryWrapperX<ConfigAssayMethodParameterDO>()
                .eqIfPresent(ConfigAssayMethodParameterDO::getConfigAssayMethodId, reqVO.getConfigAssayMethodId())
                .likeIfPresent(ConfigAssayMethodParameterDO::getParameterName, reqVO.getParameterName())
                .likeIfPresent(ConfigAssayMethodParameterDO::getShortName, reqVO.getShortName())
                .eqIfPresent(ConfigAssayMethodParameterDO::getNo, reqVO.getNo())
                .eqIfPresent(ConfigAssayMethodParameterDO::getKey, reqVO.getKey())
                .eqIfPresent(ConfigAssayMethodParameterDO::getFillingWay, reqVO.getFillingWay())
                .eqIfPresent(ConfigAssayMethodParameterDO::getDataType, reqVO.getDataType())
                .eqIfPresent(ConfigAssayMethodParameterDO::getDecimalPosition, reqVO.getDecimalPosition())
                .eqIfPresent(ConfigAssayMethodParameterDO::getDefaultValue, reqVO.getDefaultValue())
                .eqIfPresent(ConfigAssayMethodParameterDO::getIsNull, reqVO.getIsNull())
                .eqIfPresent(ConfigAssayMethodParameterDO::getIsShow, reqVO.getIsShow())
                .eqIfPresent(ConfigAssayMethodParameterDO::getSortNo, reqVO.getSortNo())
                .eqIfPresent(ConfigAssayMethodParameterDO::getDictionaryBusinessId, reqVO.getDictionaryBusinessId())
                .eqIfPresent(ConfigAssayMethodParameterDO::getDictionaryBusinessKey, reqVO.getDictionaryBusinessKey())
                .eqIfPresent(ConfigAssayMethodParameterDO::getSystemDepartmentCode, reqVO.getSystemDepartmentCode())
                .betweenIfPresent(ConfigAssayMethodParameterDO::getCreateTime, reqVO.getCreateTime())
                .eqIfPresent(ConfigAssayMethodParameterDO::getRemark, reqVO.getRemark())
                .eqIfPresent(ConfigAssayMethodParameterDO::getVersion, reqVO.getVersion())
                .orderByDesc(ConfigAssayMethodParameterDO::getId));
    }

	default List<ConfigAssayMethodParameterDO> selectByConfigAssayMethodId(Long configAssayMethodId) {
		return selectList(new LambdaQueryWrapperX<ConfigAssayMethodParameterDO>()
				.eq(ConfigAssayMethodParameterDO::getConfigAssayMethodId, configAssayMethodId));
	}
	
	default List<ConfigAssayMethodParameterDO> selectByConfigAssayMethodIds(List<Long> configAssayMethodIdList) {
		return selectList(new LambdaQueryWrapperX<ConfigAssayMethodParameterDO>()
				.in(ConfigAssayMethodParameterDO::getConfigAssayMethodId, configAssayMethodIdList));
	}

}